<template>
  <div class="profile container">
    <form class="form-widget" @submit.prevent="updateProfile">
      <Avatar v-model:path="avatar_url" @upload="updateProfile" />
      <div>
        <label for="email">Email</label>
        <input id="email" type="text" :value="store.user.email" disabled />
      </div>
      <div>
        <label for="username">Name</label>
        <input id="username" type="text" v-model="username" />
      </div>
      <div>
        <label for="website">Website</label>
        <input id="website" type="website" v-model="website" />
      </div>
      <label class="button block primary" for="update">
        {{ loading ? 'Loading ' : 'Update' }} <LoadsSpinner v-if="loading" small/>
      </label>
      <input
        style="visibility: hidden; position: absolute"
        type="submit"
        id="update"
        :value="loading ? 'Loading ...' : 'Update'"
        :disabled="loading"
      />
    </form>
  </div>
</template>

<script>
import { supabase } from "../supabase"
import { store } from "../vuex/store"
import { onMounted, ref } from "vue"
import Avatar from './Avatar.vue'
import LoadsSpinner from "./Loads-spinner.vue";
export default {
  name: "Profile",
  components: {LoadsSpinner, Avatar},
  setup() {
    const loading = ref(true)
    const username = ref("")
    const website = ref("")
    const avatar_url = ref("")

    async function getProfile() {
      try {
        loading.value = true
        store.user = supabase.auth.user()

        let { data, error, status } = await supabase
          .from("profiles")
          .select(`username, website, avatar_url`)
          .eq("id", store.user.id)
          .single()
        console.log(supabase.auth.user())

        if (error && status !== 406) throw error

        if (data) {
          username.value = data.username
          website.value = data.website
          avatar_url.value = data.avatar_url
        }
      } catch (error) {
        alert(error.message)
      } finally {
        loading.value = false
      }
    }

    async function updateProfile() {
      try {
        loading.value = true
        store.user = supabase.auth.user()

        const updates = {
          id: store.user.id,
          username: username.value,
          website: website.value,
          avatar_url: avatar_url.value,
          updated_at: new Date(),
          email: store.user.email,
        }

        let { error } = await supabase.from("profiles").upsert(updates, {
          returning: "minimal", // Don't return the value after inserting
        })

        if (error) throw error
      } catch (error) {
        alert(error.message)
      } finally {
        loading.value = false
      }
    }

    onMounted(() => {
      getProfile()
    })

    return {
      store,
      loading,
      username,
      website,
      avatar_url,

      updateProfile,
    }
  },
}
</script>

<style lang="scss">
</style>
